<%@ Language=VBScript LCID=1031%>
<%Option Explicit%>
<%Response.Buffer = true%>
<%
	Dim gDBArt, strPID1, strPID2, strCharEncoding
	Dim myDisplay, myWhere, myOrder, myWay, myPage, strTmpDatum
	Dim mySQLstr, myXMLstr, myRS, myFieldCount, i, myValue, myFieldName, mySQLstrTurbo
	Dim myLastUpdate, luID, anz, objConn, bolGetSchemeXML, bolGetLastID
	bolGetSchemeXML = False
	bolGetLastID = False
%>
<!-- #INCLUDE FILE="include/Tools.asp" -->
<!-- #INCLUDE FILE="include/Connect.asp" -->
<%

'*******************************************************************************************'
'IWWB REST Service, Windows / IIS / ADO'
'Author: Michael Weisheit'
'(c) 2003 Engine GmbH & Co KG'
'Contact: mw@engine.de'
'*******************************************************************************************'

	'============================================================'
	'Anzahl der neuen oder genderten Kurse ...'
	'============================================================'
	if Request.QueryString("method") = "getChangedCoursesCount" then

		If Len(Request.QueryString("lastUpdate")) < 8 Then
			Call WriteErrorDescription(Err,"Fehlerhafter 'lastUpdate'-Parameter !!!")
			mySQLstr = ""
		Else
			myLastUpdate = CDate(Request.QueryString("lastUpdate"))

			if gDBArt = 0 then
				strTmpDatum = "'" & month(myLastUpdate) & "/" & day(myLastUpdate) & "/" & year(myLastUpdate) & "'"
			elseif gDBArt = 1 then
				strTmpDatum = "#" & month(myLastUpdate) & "/" & day(myLastUpdate) & "/" & year(myLastUpdate) & "#"
			elseif gDBArt = 2 then
				strTmpDatum = "DATETIME(" & Year(myLastUpdate) & "," & month(myLastUpdate) & "," & day(myLastUpdate) & ")"
			end if

			mySQLstr = Replace(UCase(strSQLChangedCount), "[%DATUM%]", strTmpDatum )

		End If

	'============================================================'
	'Datenstze der neuen oder genderten Kurse als XML ...'
	'============================================================'
	elseif Request.QueryString("method") = "getChangedCoursesXML" then
		If Len(Request.QueryString("lastUpdate")) < 8 Then
			Call WriteErrorDescription(Err,"Fehlerhafter 'lastUpdate'-Parameter !!!")
			mySQLstr = ""
		Else

			myLastUpdate = CDate(Request.QueryString("lastUpdate"))

			IF Len(Request.QueryString("entries"))=0 then
				anz=1
			else
				anz = CLNG(Request.QueryString("entries"))
			end if

			if gDBArt = 0 then
				strTmpDatum = "'" & month(myLastUpdate) & "/" & day(myLastUpdate) & "/" & year(myLastUpdate) & "'"
			elseif gDBArt = 1 then
				strTmpDatum = "#" & month(myLastUpdate) & "/" & day(myLastUpdate) & "/" & year(myLastUpdate) & "#"
			elseif gDBArt = 2 then
				strTmpDatum = "DATETIME(" & Year(myLastUpdate) & "," & month(myLastUpdate) & "," & day(myLastUpdate) & ")"
			end if

			mySQLstr = Replace(UCase(strSQLChangedXML), "[%DATUM%]", strTmpDatum)
			mySQLstr = Replace(UCase(mySQLstr), "[%TOP%]", anz)

		End IF
	'============================================================'
	'Nur Schema als XML ...'
	'============================================================'
	elseif request.QueryString("method") = "getSchemeXML" then
		mySQLstr = UCase(strSQLSchemeXML)
		bolGetSchemeXML = true

	elseif Request.QueryString("method") = "getLastId" then
		mySQLstr = "SELECT [%ID1%] AS ID1,[%ID2%] AS ID2"
		bolGetLastID = true

	'============================================================'
	'Freie Select-Abfrage ... ?'
	'============================================================'
	else
		mySQLstr = Request.QueryString("freeQuery")
	end if

	If Len(Request.QueryString("pid1")) = 0 then
		strPID1="0"
	else
		strPID1=Request.QueryString("pid1")
	end if

	If Len(Request.QueryString("pid2")) = 0 then
		strPID2="0"
	else
		strPID2 = Request.QueryString("pid2")
	end if

	mySQLstr = Replace(mySQLstr, "[%ID1%]", strPID1)
	mySQLstr = Replace(mySQLstr, "[%ID2%]", strPID2)

	'Response.Write mySQLstr

	If InStr(UCase(mySQLstr), "TOP") = 0 Then
		mySQLstrTurbo =  Replace(UCase(mySQLstr), "SELECT", "SELECT TOP 1")
	Else
		mySQLstrTurbo = mySQLstr
	End If

	If Len(mySQLstr) < 20 Then
		Call WriteErrorDescription(Err,"Keine gltige Abfrage !")
	Else

		if bolGetLastID then
			CALL WriteLastIDAsXML
		else
			'============================================================'
			'Connection ffnen ...                                       '
			'============================================================'
			CALL OpenMyConnection(gConnectionString)

			'============================================================'
			'Recordsetobject vorbereiten ...                                       '
			'============================================================'
			Set myRS = Server.CreateObject("ADODB.Recordset")
			myRS.ActiveConnection = gConnection
			myRS.CursorType = 3

			' ... und ffnen
			on error resume next
			myRS.Open mySQLstrTurbo
			'============================================================'
			'FEHLER ??? ...												 '
			'============================================================'
			If Err <> 0 Then
				Set myRS = Nothing
				Call CloseMyConnection()
				Call WriteErrorDescription(Err,"Recordsetfehler : " & mySQLstrTurbo)
			else

				myFieldCount = myRS.Fields.Count

				Call WriteHeaderXML()


				IF bolGetSchemeXML then
					Call WriteSchemaXML()

				else

					Call WriteContentXML()

				end if

				on error resume next
				myRS.Close

			end if

			Set myRS = Nothing

			Call CloseMyConnection()

		end if

	End If

	Response.End

%>
